package com.autentia.workflow.utils;

import javax.annotation.Resource;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.stereotype.Service;

import com.opensymphony.workflow.InvalidActionException;
import com.opensymphony.workflow.InvalidEntryStateException;
import com.opensymphony.workflow.InvalidInputException;
import com.opensymphony.workflow.InvalidRoleException;
import com.opensymphony.workflow.Workflow;
import com.opensymphony.workflow.WorkflowException;

@Service
public class WorkflowUtils {

	private static final Log log = LogFactory.getLog(WorkflowUtils.class);

	private static final String WF_COMMISSIONING = "commissioning";

	private static final int WF_INITIAL_ACTION = 100;

	@Resource
	private Workflow workflow;

	public Long newWorkflow() throws InvalidActionException, InvalidRoleException, InvalidInputException,
			InvalidEntryStateException, WorkflowException {
		final Long id = this.workflow.initialize(WorkflowUtils.WF_COMMISSIONING, WorkflowUtils.WF_INITIAL_ACTION, null);
		return id;
	}

	public int[] getAvalaibleActions(final long wfId) {
		final int[] actions = this.workflow.getAvailableActions(wfId, null);
		return actions;
	}

	public void executeAction(final long wfId, final int actionId) throws NumberFormatException, InvalidInputException,
			WorkflowException {

		this.workflow.doAction(wfId, actionId, null);
	}
}